apiVersion: batch/v1beta1
kind: CronJob
metadata:
  labels:
    {{ network_policy_deployment_label }}: {{ s3cleanup_name }}
  name: {{ s3cleanup_name }}
  namespace: {{ namespace }}
spec:
  concurrencyPolicy: Forbid
  failedJobsHistoryLimit: 3
  jobTemplate:
    metadata:
      labels:
        name: {{ s3cleanup_name }}
    spec:
      backoffLimit: {{ job_backoff_limit | default(3) }}
      completions: {{ job_completions | default(1) }}
      parallelism: {{ job_parallelism | default(1) }}
      template:
        metadata:
          labels:
            name: {{ s3cleanup_name }}
        spec:
          automountServiceAccountToken: false
          containers:
          - args:
            - -c
            - |
                if test "$DEBUG"; then
                    set -x;
                fi;
{% if cleanup_uses_mc | default(True) %}
                cpt=0;
                while ! mc config host add myminio "$S3_REMOTE_PROTO://$S3_REMOTE_ADDRESS:$S3_REMOTE_PORT" "$S3_ACCESS_KEY" "$S3_SECRET_KEY";
                do
                    if test "$cpt" -gt 42; then
                        echo Could not reach s3 backend - bailing out;
                        exit 1;
                    fi;
                    echo Waiting for s3 backend;
                    cpt=`expr $cpt + 1`;
                    sleep 2;
                done;
                mc rm --recursive --force --older-than $PURGE_OLDER_THAN "myminio/$S3_BUCKET";
{% else %}
                s3cmd ls "s3://$3_BUCKET" | while read -r line;
                    do
                        createDate=`echo $line | awk '{print $1" "$2}'`;
                        createDate=`date -d"$createDate" +%s`;
                        olderThan=`date -d"-$PURGE_OLDER_THAN" +%s`;
                        if test "$createDate" -lt "$olderThan"; then
                            fileName=`echo $line | awk '{$1=$2=$3=""; print $0}' | sed 's/^[ \t]*//'`;
                            if test "$fileName"; then
                                 echo "purging $fileName";
                                 s3cmd del "$fileName";
                            fi;
                        fi;
                    done;
{% endif %}
                exit 0
            command:
            - /bin/sh
            env:
            - name: HOME
              value: /empty
            - name: PURGE_OLDER_THAN
              value: {{ s3_retention | default('7d') }}
            - name: S3_ACCESS_KEY
              valueFrom:
                secretKeyRef:
                  key: access-key
                  name: {{ s3_secret_name }}
            - name: S3_BUCKET
              valueFrom:
                secretKeyRef:
                  key: bucket
                  name: {{ s3_secret_name }}
            - name: S3_REMOTE_ADDRESS
              value: {{ s3_address | urlsplit('hostname') }}
            - name: S3_REMOTE_PORT
              value: "{{ s3_address | urlsplit('port') }}"
            - name: S3_REMOTE_PROTO
              value: "{{ s3_address | urlsplit('scheme') }}"
            - name: S3_REGION
              valueFrom:
                secretKeyRef:
                  key: region
                  name: {{ s3_secret_name }}
            - name: S3_SECRET_KEY
              valueFrom:
                secretKeyRef:
                  key: secret-key
                  name: {{ s3_secret_name }}
            image: {{ (opsimages | json_query("[?name=='backups'].image"))[0] }}
            imagePullPolicy: {{ pull_policy }}
            name: s3cleanup
            resources:
              limits:
                cpu: "{{ s3cleanup_cpu_limit }}"
                memory: "{{ s3cleanup_memory_limit }}"
              requests:
                cpu: "{{ s3cleanup_cpu_request }}"
                memory: "{{ s3cleanup_memory_request }}"
            volumeMounts:
            - mountPath: /empty
              name: empty
          restartPolicy: OnFailure
          securityContext:
            runAsUser: {{ k8s_unprivileged_userid }}
          volumes:
          - emptyDir: {}
            name: empty
  schedule: 0 2 * * *
  startingDeadlineSeconds: 120
  successfulJobsHistoryLimit: 1
  suspend: false
